const _Http = getApp().globalData.http;

import {
  fileList
} from "../../utils/FormatTheAttachment";

Page({
  data: {
    loading: true
  },
  onLoad(options) {
    if (options.id) this.setData({
      sa_itemgroupid: options.id,
      itemno: options.itemno
    })
    this.getDetail();
  },
  /* 获取详情 */
  getDetail() {
    _Http.basic({
      "id": "20221223165503",
      "content": {
        "sa_itemgroupid": this.data.sa_itemgroupid,
        itemno: this.data.itemno
      }
    }).then(res => {
      console.log("商品详情", res)
      if (res.msg != '成功') return wx.showToast({
        title: res.msg,
        icon: "none"
      })
      this.handleFiles(res.data.item[0].attinfos)
      this.setData({
        detail: res.data.item[0],
        rows: res.data.rows,
        loading: false
      })
    })
  },
  /* 预览媒体 */
  viewMedias(e) {
    const {
      index,
      type
    } = e.currentTarget.dataset;
    wx.previewMedia({
      current: index,
      sources: type == 'image' ? this.data.files.viewImages : this.data.files.viewVideos,
    })
  },
  /* 处理附件 */
  handleFiles(arr) {
    let files = {
        images: [],
        viewImages: [],
        videos: [],
        viewVideos: [],
        files: []
      },
      list = fileList(arr);
    list.forEach(v => {
      switch (v.fileType) {
        case "video":
          files.videos.push(v)
          files.viewVideos.push({
            url: v.url,
            type: "video",
            poster: v.subfiles[0].url
          })
          break;
        case "image":
          files.images.push(v)
          files.viewImages.push({
            url: v.url,
            type: "image"
          })
          break;
        default:
          files.files.push(v)
          break;
      }
    });
    this.setData({
      files
    })
  },
  /* 切换产品 */
  changeItemno(e) {
    const {
      item
    } = e.currentTarget.dataset;
    if (item.itemno == this.data.itemno) return;
    this.setData({
      itemno: item.itemno
    });
    this.getDetail();
  },
  clickBut() {
    this.data.detail.tradefield.length >= 2 ? wx.showToast({
      title: '请选择加入产品领域',
      icon: "none",
      duration: 3000
    }) : this.handleStorage(0);
  },
  /* 选择领域 */
  storage(e) {
    this.handleStorage(e.detail.value)
  },
  handleStorage(index) {
    let detail = this.data.detail;
    _Http.basic({
      "id": 20220924095102,
      "content": {
        "sa_brandid": detail.brand[0].sa_brandid, //品牌id
        "itemid": detail.itemid, //货品id
        "qty": 1, //数量
        "itemno": this.data.itemno, //货品编号
        tradefield: detail.tradefield[index].tradefield
      },
    }).then(res => {
      console.log("加入购物车", res)
      wx.showToast({
        title: res.msg != '成功' ? res.msg : '已将产品加入到购物车',
        icon: "none"
      });
      if (res.msg == '成功') _Http.basic({
        "id": 20220927093202,
        "content": {}
      }, false).then(res => {
        console.log("购物车数量", res)
        getApp().globalData.num = res.data.num;
        this.selectComponent("#Float").setNum(res.data.num)
      });
    })
  },
  onShow() {
    this.selectComponent("#Float").setNum(getApp().globalData.num)
  },
})